<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>hw_3</title>
</head>
<body>
<header>
</header>
<main>
    <div>
        <h1>
            7 tools for visualizing a codebase
        </h1>
    </div>
    <pre>
Need to write a README file, but not sure what to say? If this is a <mark>frustration</mark>
that bothers you frequently, you might consider beefing your document up
with a diagram. After all, a picture is worth a thousand words, as the cliche
goes.

<img src="https://miro.medium.com/v2/resize:fit:1400/0*w952tps00S4Jy1cf"  height="467" wight="800" alt="eror" >
   Photo by  <a href="https://unsplash.com/@hcmorr?utm_source=unsplash&utm_medium=referral&utm_content=creditCopyText">Hanna Morris</a> on <a href="https://unsplash.com/@hcmorr?utm_source=unsplash&utm_medium=referral&utm_content=creditCopyText">Unsplash</a>

This article collects tools that generates graphs for a code repository.
    </pre>
    <div>
    <h2>
        Visualize files by size and type
    </h2>
    </div>
    <pre>
Let’s <b>start with the most generic</b> tool, <a href="https://github.com/githubocto/repo-visualizer">repo-visualizer</a>. It plots files as
bubbles, indicating their extension names and sizes with colors and sizes,
respectively. It's <a href="https://githubnext.com/projects/repo-visualization/">brought to you</a> by <a href="https://githubnext.com">GitHub Next</a>, a lab at GitHub the
company, and (naturally) it's packaged as a <a href="https://github.com/features/actions">GitHub Action</a>.
    </pre>
    <div>
        <h2>
            Visualize Docker Compose files
        </h2>
    </div>
    <pre>
The next tool specifically caters to Docker users, but it’s still language-
agnostic. To visualize <mark>docker-compose.yml</mark>,you can use <a href="https://github.com/pmsipilot/docker-compose-viz">docker-compose-viz:</a>


<font style="background-color: lightgrey">docker run \--rm \-it \--name dcv \-v $(pwd):/input pmsipilot/docker-
compose-viz render \-m image docker-compose.yml </font>

Here’s how it would look:

<img src="https://miro.medium.com/v2/resize:fit:834/0*yxLDD4lCKKvP-_Yt.png" height="676" wight="417" alt="eror">

I like how it’s also plotting extra information like open ports and mounted
volumes.
    </pre>
    <div>
        <h2>
            Visualize <a href="https://en.wikipedia.org/wiki/Call_graph">call graphs</a>
        </h2>
    </div>
    <pre>
<a href="https://github.com/scottrogowski/code2flow">Code2flow</a>supports a couple of <b>dynamic</b> languages, including Python,
JavaScript, Ruby, and PHP.

Here’s the example provided in its README:

<font style="background-color: lightgrey">code2flow code2flow/engine.py code2flow/python.py --target-
function=code2flow --downstream-depth=3</font>

<img src="https://miro.medium.com/v2/resize:fit:1070/1*ley51O4jvxpkKqu11SHIQg.png" height="506" wight="535" alt="eror">

Call graph of a student project by <a href="https://twitter.com/pamelafox">Pamela Fox</a>.<a href="https://inst.eecs.berkeley.edu/~cs61a/sp22/assets/slides/30-Modularity.html#/17">Slides</a>.

If <b>Python</b> is the only language you care about, you might have heard of
<a href="https://github.com/gak/pycallgraph">pycallgraph</a>, but -- alas, the bane of open source software projects -- the
original author had to abandon the project due to personal time constraints.
The most sensible <b>alternative</b> I can find is <a href="https://github.com/davidfraser/pyan">pyan</a>.

<font style="background-color: lightgrey">pyan *.py --uses --no-defines --colored --grouped --annotated --svg
>myuses.svg</font>

 <img src="https://miro.medium.com/v2/resize:fit:1400/0*HLHpLcjzF0n8V9bI.png" height="194" wight="700" alt="eror">
    </pre>
<div>
    <h2>
        Visualize dependencies
    </h2>
</div>
    <pre>
A fundamental functionality of build systems and package managers is
dependency resolution. As you’d expect, many visualization tools tap into
dependency graphs generated by these software to plot diagrams for
a repository.

Under the hood, most of these tools use <mark>graphviz</mark> for the actual plotting
work. Therefore, don't be surprised to discover that the diagrams share a
similar style.

<a href="https://bazel.build">Bazel</a>is a language-agnostic build system. The developers behind <b>Bazel</b>
know its users so well that they put up an <a href="https://blog.bazel.build/2015/06/17/visualize-your-build.html">official guide</a> for visualizing
dependencies defined with Bazel:

<font style="background-color: lightgrey">bazel query 'deps(//:main)' --output graph > dependencies.in
dot -Tpng < dependencies.in > dependencies.svg</font>

It gives something like this:

<img src="https://miro.medium.com/v2/resize:fit:402/0*f2OSom4CWV4X5dtD.png" height="253" wight="201" alt="eror">

For <b>Python</b> packages in an environment, use <a href="https://pypi.org/project/pipdeptree/">pipdeptree</a>:

<font style="background-color: lightgrey">pipdeptree --graph-output svg > dependencies.svg</font>

<img src="https://miro.medium.com/v2/resize:fit:1400/0*Xm3JnqySRwwDitAq" height="279" wight="700" alt="eror">

For <b>Java</b> projects built with <a href="https://maven.apache.org">Maven</a>, <a href="https://github.com/ferstl/depgraph-maven-plugin">depgraph-maven-plugin</a> is the way to go:

<font style="background-color: lightgrey">mvn com.github.ferstl:depgraph-maven-plugin:graph</font>

<img src="https://miro.medium.com/v2/resize:fit:1400/0*JPLMYwrGpH-H0jPh.png" height="246" wight="201" alt="eror">
    </pre>
    <div>
        <h2>
            I want more interactivity!
        </h2>
    </div>
    <pre>
Maybe you’re not here to fill up your README; rather, you just want to learn
about a repo as quickly and intuitively as possible. If that’s the case, there are
some nice tools you can play with:
<ul><li><a href="https://gource.io">Gource</a>: A locally-run software.</li>
    <li><a href="https://www.codesee.io">CodeSee</a>: A cloud service that offers paid plans.</li></ul>
I’m not endorsing either of them, and they are beyond the scope of this post.
Nevertheless, this serves as a good point to wrap up this post. Writing an
ending is painful, and I’m sure you’re aware of that — Otherwise, you would
not have landed on this very article that helps you evade the chore of
composing words, would you?
    </pre>
</main>
<footer>
</footer>
</body>
</html>